Index: /DCWoRMS/trunk/build/classes/example/globalplugin/GridFCFSRandomPlugin.java
===================================================================
--- /DCWoRMS/trunk/build/classes/example/globalplugin/GridFCFSRandomPlugin.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/example/globalplugin/GridFCFSRandomPlugin.java	(revision 539)
@@ -53,5 +53,5 @@
 		
 		for(int i = 0; i < size; i++) {
-			WorkloadUnit<?> job = q.remove(0);
+			WorkloadUnit job = q.remove(0);
 			TaskInterface<?> task = (TaskInterface<?>)job;
 			
@@ -75,12 +75,3 @@
 	}
 
-
-	public String getName() {
-		return getClass().getName();
-	}
-
-	public void init(Properties properties) {
-		// no extra initialization is expected.
-	}
-
 }
Index: /DCWoRMS/trunk/build/classes/example/globalplugin/GridFCFSRoundRobinPlugin.java
===================================================================
--- /DCWoRMS/trunk/build/classes/example/globalplugin/GridFCFSRoundRobinPlugin.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/example/globalplugin/GridFCFSRoundRobinPlugin.java	(revision 539)
@@ -47,5 +47,5 @@
 		
 		for(int i = 0; i < size; i++) {
-			WorkloadUnit<?> job = q.remove(0);
+			WorkloadUnit job = q.remove(0);
 			TaskInterface<?> task = (TaskInterface<?>)job;
 			
@@ -65,5 +65,4 @@
 			allocation.setProcessesCount(1);
 			allocation.setProviderName(sd.getProvider().getProviderId());
-			System.out.println("----" + sd.getProvider().getProviderId());
 			ScheduledTask scheduledTask = new ScheduledTask(task);
 			scheduledTask.setTaskId(task.getId());
@@ -76,8 +75,3 @@
 	}
 
-	public String getName() {
-		return getClass().getName();
-	}
-
-
 }
Index: /DCWoRMS/trunk/build/classes/example/globalplugin/BaseGlobalPlugin.java
===================================================================
--- /DCWoRMS/trunk/build/classes/example/globalplugin/BaseGlobalPlugin.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/example/globalplugin/BaseGlobalPlugin.java	(revision 539)
@@ -4,5 +4,5 @@
 import schedframe.PluginConfiguration;
 import schedframe.events.scheduling.SchedulingEventType;
-import schedframe.scheduling.WorkloadUnitListImpl;
+import schedframe.scheduling.TaskList;
 import schedframe.scheduling.manager.resources.ResourceManager;
 import schedframe.scheduling.plugin.SchedulingPluginConfiguration;
@@ -11,5 +11,5 @@
 import schedframe.scheduling.queue.TaskQueue;
 import schedframe.scheduling.queue.TaskQueueList;
-import schedframe.scheduling.tasks.WorkloadUnit;
+import schedframe.scheduling.tasks.TaskInterface;
 import schemas.StringValueWithUnit;
 
@@ -22,5 +22,5 @@
 	}
 	
-	public int placeJobsInQueues(WorkloadUnitListImpl newJobs, TaskQueueList queues, ResourceManager resourceManager,
+	public int placeTasksInQueues(TaskList newTasks, TaskQueueList queues, ResourceManager resourceManager,
 			ModuleList moduleList) {
 
@@ -28,6 +28,6 @@
 		TaskQueue queue = queues.get(0);
 
-		for (int i = 0; i < newJobs.size(); i++) {
-			WorkloadUnit<?> task = newJobs.get(i);
+		for (int i = 0; i < newTasks.size(); i++) {
+			TaskInterface<?> task = newTasks.get(i);
 			queue.add(task);
 		}
@@ -46,4 +46,7 @@
 	}
 	
+	public String getName() {
+		return getClass().getName();
+	}
 	
 }
Index: /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/plugin/local/DCWormsTimeOperations.java
===================================================================
--- /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/plugin/local/DCWormsTimeOperations.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/plugin/local/DCWormsTimeOperations.java	(revision 539)
@@ -0,0 +1,25 @@
+package dcworms.schedframe.scheduling.plugin.local;
+
+import org.joda.time.DateTime;
+
+import schedframe.scheduling.plugin.local.TimeOperations;
+
+public class DCWormsTimeOperations extends TimeOperations {
+
+	public DCWormsTimeOperations(){
+		this(0);
+	}
+	
+	public DCWormsTimeOperations(long timeDelta){
+		super(timeDelta);
+	}
+
+	/**
+	 * Get Calendar object representing current logic time
+	 * @return current time
+	 */
+	public DateTime getTime() {
+		return new DateTime();
+	}
+
+}
Index: /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/utils/TaskDescription.java
===================================================================
--- /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/utils/TaskDescription.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/utils/TaskDescription.java	(revision 539)
@@ -0,0 +1,108 @@
+package dcworms.schedframe.scheduling.utils;
+
+import java.io.StringReader;
+
+import org.exolab.castor.xml.MarshalException;
+import org.exolab.castor.xml.ResolverException;
+import org.exolab.castor.xml.Unmarshaller;
+import org.exolab.castor.xml.ValidationException;
+import org.exolab.castor.xml.XMLContext;
+
+import org.qcg.broker.schemas.jobdesc.Task;
+
+import schedframe.DescriptionContainer;
+
+public class TaskDescription implements DescriptionContainer<Task> {
+
+	
+	protected static Unmarshaller unmarshaller;
+	static {
+		XMLContext context = new XMLContext();
+		try {
+			context.addClass(org.qcg.broker.schemas.jobdesc.Task.class);
+			unmarshaller = context.createUnmarshaller();
+		} catch (ResolverException e) {
+			e.printStackTrace();
+			unmarshaller = null;
+		}
+	}
+	
+	protected String xml;
+	protected Task task;
+	protected String taskId;
+	protected String userDn;
+	protected long submissionTime;
+	protected long taskLength;
+	protected long waitTime;
+	
+	
+	public TaskDescription(String xmlTask){
+		xml = xmlTask;
+	}
+	
+	public String getTaskId(){
+		return taskId;
+	}
+	
+	public void setTaskId(String id){
+		this.taskId = id;
+	}
+	
+	
+	
+	public void discardUnused(){
+		xml = null;
+		task = null;
+	}
+	
+	public Task getDescription() {
+		if(task == null){
+			try {
+				task = (Task) unmarshaller.unmarshal(new StringReader(xml));
+			} catch (MarshalException e) {
+				e.printStackTrace();
+			} catch (ValidationException e) {
+				e.printStackTrace();
+			}
+		}
+		
+		return task;
+	}
+
+	public String getDocument() throws Exception {
+		return xml;
+	}
+
+	public String getUserDn() {
+		return userDn;
+	}
+
+	public void setUserDn(String userDn) {
+		this.userDn = userDn;
+	}
+
+	public long getSubmissionTime() {
+		return submissionTime;
+	}
+
+	public void setSubmissionTime(long submissionTime) {
+		this.submissionTime = submissionTime;
+	}
+
+	public long getTaskLength() {
+		return taskLength;
+	}
+
+	public void setTaskLength(long taskLength) {
+		this.taskLength = taskLength;
+	}
+	
+	public long getWorkloadLogWaitTime() {
+		return waitTime;
+	}
+
+	public void setWorkloadLogWaitTime(long waitTime) {
+		this.waitTime = waitTime;
+	}
+
+}
Index: /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/utils/JobDescription.java
===================================================================
--- /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/utils/JobDescription.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/utils/JobDescription.java	(revision 539)
@@ -0,0 +1,73 @@
+package dcworms.schedframe.scheduling.utils;
+
+import java.io.StringReader;
+import java.util.ArrayList;
+
+import org.exolab.castor.xml.MarshalException;
+import org.exolab.castor.xml.ResolverException;
+import org.exolab.castor.xml.Unmarshaller;
+import org.exolab.castor.xml.ValidationException;
+import org.exolab.castor.xml.XMLContext;
+
+import schedframe.DescriptionContainer;
+
+import org.qcg.broker.schemas.jobdesc.QcgJob;
+
+
+public class JobDescription extends ArrayList<TaskDescription> implements DescriptionContainer<QcgJob>{
+
+	private static final long serialVersionUID = 7853990656207447619L;
+	protected static Unmarshaller unmarshaller;
+	static {
+		XMLContext context = new XMLContext();
+		try {
+			context.addClass(org.qcg.broker.schemas.jobdesc.QcgJob.class);
+			unmarshaller = context.createUnmarshaller();
+		} catch (ResolverException e) {
+			e.printStackTrace();
+			unmarshaller = null;
+		}
+	}
+	
+	protected String xml;
+	protected QcgJob job;
+	protected String jobId;
+	
+	public JobDescription(String xmlJobDesc) throws MarshalException, ValidationException{
+		xml = xmlJobDesc;
+	}
+	
+	public String getJobId(){
+		return this.jobId;
+	}
+	
+	public void setJobId(String id){
+		this.jobId = id;
+	}
+	
+	public void discardUnused(){
+		job = null;
+		xml = null;
+		for(int i = 0; i < size(); i++){
+			get(i).discardUnused();
+		}
+	}
+	
+	public QcgJob getDescription() {
+		if(job == null){
+			try {
+				job = (QcgJob) unmarshaller.unmarshal(new StringReader(xml));
+			} catch (MarshalException e) {
+				e.printStackTrace();
+			} catch (ValidationException e) {
+				e.printStackTrace();
+			}
+		}
+		return job;
+	}
+
+	public String getDocument() throws Exception {
+		return xml;
+	}
+
+}
Index: /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/Executable.java
===================================================================
--- /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/Executable.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/Executable.java	(revision 539)
@@ -0,0 +1,367 @@
+package dcworms.schedframe.scheduling;
+
+
+import gridsim.GridSim;
+import gridsim.dcworms.DCWormsTags;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.commons.lang.ArrayUtils;
+import org.joda.time.DateTime;
+import org.joda.time.DateTimeUtilsExt;
+import org.joda.time.ReadableDuration;
+
+
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.units.ProcessingElements;
+import schedframe.resources.units.StandardResourceUnitName;
+import schedframe.scheduling.ResourceHistoryItem;
+import schedframe.scheduling.UsedResourcesList;
+import schedframe.scheduling.WorkloadUnitHandler;
+import schedframe.scheduling.manager.tasks.JobRegistryImpl;
+import schedframe.scheduling.tasks.AbstractProcesses;
+import schedframe.scheduling.tasks.AbstractProcessesGroup;
+import schedframe.scheduling.tasks.Task;
+import schedframe.scheduling.tasks.requirements.ResourceParameterName;
+
+/**
+ * 
+ * @author Marcin Krystek
+ *
+ */
+public class Executable implements ExecTask{
+
+	protected Task task;
+	protected String processesSetId;
+	
+	protected int status; 
+	protected double length;
+	protected Map<ResourceParameterName, Object> specificResources;
+	
+	protected String reservationId;
+	protected double completionPercentage;
+	
+	protected int estimatedDuration;
+	//TO DO remove and benefit from visitedResources
+	protected String schedName;
+	protected UsedResourcesList usedResources;
+	//TO DO consider removing
+	protected List<String> visitedResources;
+
+	protected double submissionTime;
+    protected double arrivalTime;
+	protected double execStartTime ;
+    protected double totalCompletionTime; 
+	protected double finishTime; 
+	
+	public Executable(Task t){
+		this.task = t;
+		this.status = DCWormsTags.CREATED;
+		
+		this.usedResources = new UsedResourcesList();
+		this.visitedResources = new ArrayList<String>();
+		init();
+	}
+	
+	public Executable(Task t, AbstractProcesses procesesSet){
+		this.task = t;
+		this.status = DCWormsTags.CREATED;
+		this.processesSetId = procesesSet.getId(); 
+		
+		this.usedResources = new UsedResourcesList();
+		this.visitedResources = new ArrayList<String>();
+		init();
+	}
+	
+	protected void init() {
+		double currentTime = DateTimeUtilsExt.getDateTimeAt(arrivalTime).getMillis() / 1000;
+		this.submissionTime =  currentTime;
+        this.totalCompletionTime = 0.0;
+	 }
+	
+	public int getUserId() {
+		return task.getSenderId();
+	}
+	public String getUserDN() {
+		return task.getUserDN();
+	}
+
+	public String getJobId() {
+		return task.getJobId();
+	}
+	
+	public String getTaskId(){
+		return this.task.getId();
+	}
+	
+	public String getId() {
+		if(processesSetId == null)
+			return task.getId();
+		else 
+			return task.getId() + "_" + processesSetId;
+	}
+	
+	public String getProcessesId(){
+		return this.processesSetId;
+	}
+	
+    public int getUniqueId(){
+    	if(processesSetId == null){
+    		return (task.getJobId() + "_" + task.getId()).hashCode();
+    	} else {
+    		return (task.getJobId() + "_" + task.getId() + "_" + processesSetId).hashCode();
+    	}
+    }
+    
+	public List<AbstractProcesses> getProcesses() {
+		return task.getProcesses();
+	}
+
+	public List<AbstractProcesses> getProcesses(
+			AbstractProcessesGroup processGroup) {
+		return task.getProcesses(processGroup);
+	}
+
+	public List<AbstractProcessesGroup> getProcessesGroups() {
+		return task.getProcessesGroups();
+	}
+
+	public org.qcg.broker.schemas.resreqs.Task getDescription() {
+		return task.getDescription();
+	}
+
+	public String getDocument() throws Exception {
+		return task.getDocument();
+	}
+	
+	public long getLength() {
+		return task.getLength();
+	}
+
+	public int getStatus() {
+		return status;
+	}
+	
+	public boolean isFinished()
+    {
+		return task.isFinished();
+    }
+	
+	public void setStatus(int newStatus) throws Exception {
+		int prevStatus = status;
+	    
+        if (status == newStatus) {
+            return;
+        }
+
+        if (newStatus < DCWormsTags.CREATED || newStatus > DCWormsTags.FAILED_RESOURCE_UNAVAILABLE) {
+            throw new Exception("Executable.setStatuts() : Error - " +
+                    "Invalid integer range for Execiutable status.");
+        }
+
+        status = newStatus;
+        double currentTime = DateTimeUtilsExt.currentTimeMillis() / 1000; // time in seconds 
+    
+		
+		if (newStatus == DCWormsTags.SUCCESS || newStatus == DCWormsTags.CANCELED) {
+            finishTime = DateTimeUtilsExt.currentTimeMillis() / 1000;
+        }
+		
+		if(newStatus == DCWormsTags.SUBMITTED){
+			 arrivalTime = GridSim.clock();
+		}
+
+        if (prevStatus == DCWormsTags.INEXEC) {
+            if (status == DCWormsTags.CANCELED || status == DCWormsTags.PAUSED ||
+                status == DCWormsTags.SUCCESS) {
+                totalCompletionTime += (currentTime -  execStartTime);
+            }
+        }
+
+        if (prevStatus == DCWormsTags.RESUMED && status == DCWormsTags.SUCCESS) {
+            totalCompletionTime += (currentTime -  execStartTime);
+        }
+
+        if (status == DCWormsTags.INEXEC ||
+            (prevStatus == DCWormsTags.PAUSED && status == DCWormsTags.RESUMED) ) {
+        	execStartTime = currentTime;
+        	
+    		ProcessingElements pes = (ProcessingElements) getUsedResources().getLast().getResourceUnits().get(StandardResourceUnitName.PE);
+    		for (ComputingResource resource : pes) {
+
+    			trackResource(resource.getName());
+    			
+    			ComputingResource parent = resource.getParent();
+				List<String> visitedResource = getVisitedResources();
+				String [] visitedResourcesArray = visitedResource.toArray(new String[visitedResource.size()]);
+    			while (parent != null && !ArrayUtils.contains(visitedResourcesArray, parent.getName())) {
+    				trackResource(parent.getName());
+    				parent = parent.getParent();
+    			}
+    		}
+        }
+	}
+	
+	public void addSpecificResource(ResourceParameterName resourceName, Object value){
+		if(this.specificResources == null)
+			this.specificResources = new HashMap<ResourceParameterName, Object>();
+		
+		this.specificResources.put(resourceName, value);
+	}
+
+	public boolean expectSpecificResource(ResourceParameterName resourceName){
+		if(this.specificResources == null)
+			return false;
+
+		return this.specificResources.containsKey(resourceName);
+	}
+	
+	public Object getExpectedSpecificResource(ResourceParameterName resourceName){
+		if(this.specificResources == null)
+			return null;
+		
+		return this.specificResources.get(resourceName);
+	}
+	
+	public void setReservationId(String reservationId){
+		this.reservationId = reservationId;
+	}
+	
+	public boolean requireReservation(){
+		return (reservationId != null);
+	}
+	
+	public String getReservationId(){
+		return this.reservationId;
+	}
+	
+	public double getCompletionPercentage() {
+		return completionPercentage;
+	}
+
+	public void setCompletionPercentage(double completionPercentage) {
+		this.completionPercentage = completionPercentage;
+	}
+
+	public void addUsedResources(ResourceHistoryItem usedResources){
+		this.usedResources.add(usedResources);
+	}
+	
+	public UsedResourcesList getUsedResources(){
+		return this.usedResources;
+	}
+	
+    public void setSchedulerName(int resourceId)
+    {
+        this.schedName = GridSim.getEntityName(resourceId);
+    }
+
+    public String getSchedulerName()
+    {
+        return schedName;
+    }
+	
+	public int getEstimatedDuration(){
+		return this.estimatedDuration;
+	}
+	
+	public void setEstimatedDuration(int value){
+		this.estimatedDuration = value;
+	}
+
+	public boolean isRegistered() {
+		return task.isRegistered();
+	}
+
+	public void register(JobRegistryImpl jobRegistry) {
+		task.register(jobRegistry);
+	}
+	
+	public void trackResource(String resName){
+		visitedResources.add(resName);
+	}
+	
+	public List<String> getVisitedResources(){
+		return visitedResources;
+	}
+	
+	public ReadableDuration getExpectedDuration() throws NoSuchFieldException {
+		return task.getExpectedDuration();
+	}
+
+	public double getParameterDoubleValue(ResourceParameterName parameterName)
+			throws NoSuchFieldException, IllegalArgumentException {
+		return task.getParameterDoubleValue(parameterName);
+	}
+
+	public String getParameterStringValue(ResourceParameterName parameterName)
+			throws NoSuchFieldException, IllegalArgumentException {
+		return task.getParameterStringValue(parameterName);
+	}
+	
+	public double getCpuCntRequest() throws NoSuchFieldException{
+		return getParameterDoubleValue(ResourceParameterName.CPUCOUNT);
+	}
+	
+	public double getMemoryRequest() throws NoSuchFieldException{
+		return getParameterDoubleValue(ResourceParameterName.MEMORY);
+	}
+	
+	public DateTime getExecutionEndTime() throws NoSuchFieldException {
+		return task.getExecutionEndTime();
+	}
+
+	public DateTime getExecutionStartTime() throws NoSuchFieldException {
+		return task.getExecutionStartTime();
+	}
+
+	public DateTime getSubmissionTimeToBroker() {
+		return task.getSubmissionTimeToBroker();
+	}
+
+	public long getWorkloadLogWaitTime() {
+		return task.getWorkloadLogWaitTime();
+	}
+
+    public double getExecStartTime() {
+        return execStartTime;
+    }
+
+    public double getFinishTime() {
+        return finishTime;
+    }
+
+    public double getSubmissionTime() {
+        return submissionTime;
+    }
+    
+    public double getWaitingTime()
+    {
+        return execStartTime - submissionTime;
+    }
+    
+    public void finalizeExecutable(){
+		try {
+			setStatus(DCWormsTags.SUCCESS);
+		} catch (Exception e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+    }
+    
+	public void accept(WorkloadUnitHandler wuh) {
+		wuh.handleExecutable(this);
+	}
+    
+	public boolean equals(Object obj){
+		if(obj instanceof Executable){
+			Executable t = (Executable) obj;
+			return getId().equals(t.getId());
+		}
+		return false;
+	}
+
+}
Index: /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/ExecTask.java
===================================================================
--- /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/ExecTask.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/ExecTask.java	(revision 539)
@@ -0,0 +1,15 @@
+package dcworms.schedframe.scheduling;
+
+import java.util.List;
+
+import schedframe.scheduling.tasks.TaskInterface;
+import schedframe.scheduling.tasks.requirements.ResourceParameterName;
+
+public interface ExecTask extends TaskInterface<org.qcg.broker.schemas.resreqs.Task> {
+
+	public boolean expectSpecificResource(ResourceParameterName resourceName);	
+	public Object getExpectedSpecificResource(ResourceParameterName resourceName);
+
+	public void trackResource(String resName);
+	public List<String> getVisitedResources();
+}
Index: /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/queues/AbstractStatsSupportingQueue.java
===================================================================
--- /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/queues/AbstractStatsSupportingQueue.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/dcworms/schedframe/scheduling/queues/AbstractStatsSupportingQueue.java	(revision 539)
@@ -0,0 +1,106 @@
+package dcworms.schedframe.scheduling.queues;
+
+import java.util.ArrayList;
+import java.util.Collection;
+
+import schedframe.scheduling.queue.Queue;
+
+
+import eduni.simjava.Sim_stat;
+import eduni.simjava.Sim_system;
+
+
+/**
+ * 
+ * @author Marcin Krystek
+ *
+ * @param <K>
+ */
+
+public abstract class AbstractStatsSupportingQueue<K> extends ArrayList<K> implements Queue<K>{
+
+	private static final long serialVersionUID = 2067736388365966634L;
+	protected double lastUpdateTime;
+	protected Sim_stat stats;
+	protected String measureName;
+	
+	protected AbstractStatsSupportingQueue(){
+		this.stats = null;
+		this.lastUpdateTime = 0.0;
+		this.measureName = null;
+	}
+	
+	public boolean add(K o) {
+		boolean ret = super.add(o);
+		updateStats();
+		return ret;
+	}
+
+	public void add(int index, K element) {
+		super.add(index, element);
+		updateStats();
+	}
+
+	public boolean addAll(Collection<? extends K> c) {
+		boolean ret = super.addAll(c);
+		updateStats();
+		return ret;
+	}
+
+	public boolean addAll(int index, Collection<? extends K> c) {
+		boolean ret = super.addAll(index, c);
+		updateStats();
+		return ret;
+	}
+
+	public void clear() {
+		super.clear();
+		updateStats();
+	}
+
+	public boolean remove(Object o) {
+		boolean ret = super.remove(o);
+		updateStats();
+		return ret;
+	}
+
+	public K remove(int index) {
+		 K ret = super.remove(index);
+		 updateStats();
+		 return ret;
+	}
+
+	public boolean removeAll(Collection<?> c) {
+		boolean ret = super.removeAll(c);
+		updateStats();
+		return ret;
+	}
+
+	public boolean retainAll(Collection<?> c) {
+		boolean ret = super.retainAll(c);
+		updateStats();
+		return ret;
+	}
+
+	public K set(int index, K element) {
+		K ret = super.set(index, element);
+		updateStats();
+		return ret;
+	}
+	
+	
+	public void setStats(Sim_stat stats, String measureName){
+		this.stats = stats;
+		this.measureName = measureName;
+	}
+	
+	protected void updateStats() {
+		if(stats == null)
+			return;
+		
+		double time = Sim_system.clock();
+		stats.update(measureName, size(), lastUpdateTime); //continuous
+		lastUpdateTime = time;
+	}
+	
+}
Index: /DCWoRMS/trunk/build/classes/gridsim/dcworms/filter/ExecTaskFilter.java
===================================================================
--- /DCWoRMS/trunk/build/classes/gridsim/dcworms/filter/ExecTaskFilter.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/gridsim/dcworms/filter/ExecTaskFilter.java	(revision 539)
@@ -0,0 +1,45 @@
+package gridsim.dcworms.filter;
+
+import dcworms.schedframe.scheduling.Executable;
+import eduni.simjava.Sim_event;
+import gridsim.filter.FilterResult;
+
+/**
+ * @author wojtek
+ *
+ */
+public class ExecTaskFilter extends FilterResult {
+
+	public ExecTaskFilter(int taskId, int tag) {
+		super(taskId, tag);
+	}
+
+	public boolean match(Sim_event ev) {
+
+		if (ev == null) {
+			return false;
+		}
+
+		boolean result = false;
+		try {
+
+			if (tag_ == ev.get_tag()) {
+				Object obj = ev.get_data();
+
+				if (obj instanceof Executable) {
+
+					Executable exec = (Executable) obj;
+
+					if (exec.getUniqueId() == eventID_) {
+						result = true;
+					}
+				}
+			}
+		} catch (Exception e) {
+			result = false;
+		}
+
+		return result;
+	}
+
+}
Index: /DCWoRMS/trunk/build/classes/gridsim/dcworms/DCWormsTags.java
===================================================================
--- /DCWoRMS/trunk/build/classes/gridsim/dcworms/DCWormsTags.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/gridsim/dcworms/DCWormsTags.java	(revision 539)
@@ -0,0 +1,53 @@
+package gridsim.dcworms;
+
+import gridsim.GridSimTags;
+
+/**
+ * @author Marcin Krystek
+ */
+public class DCWormsTags extends GridSimTags {
+	
+	protected static final int DCWORMSBASE = 600; 
+	
+	public static final int UPDATE= DCWORMSBASE - 1;
+	
+	public static final int TIMER = DCWORMSBASE + 1;
+	
+	public static final int TASK_READY_FOR_EXECUTION = DCWORMSBASE + 2;
+	
+	public static final int TASK_EXECUTION_FINISHED = DCWORMSBASE + 3;
+	
+
+	/**
+	 * Message tag: query resource about its current state in object form (load, queues, etc.)
+	 */ 
+	public static final int QUERY_RESOURCE_DESC = DCWORMSBASE + 4; 
+
+	public static final int QUERY_RESOURCE_DESC_RESULT = DCWORMSBASE + 5; 
+	
+	public static final int TASK_REQUESTED_TIME_EXPIRED = DCWORMSBASE + 6;
+
+	
+    public static final int CREATED = 0;
+
+    public static final int SUBMITTED = 1;
+    
+    public static final int READY = 2;
+
+    public static final int QUEUED = 3;
+
+    public static final int INEXEC = 4;
+
+    public static final int SUCCESS = 5;
+
+    public static final int FAILED = 6;
+
+    public static final int CANCELED = 7;
+
+    public static final int PAUSED = 8;
+
+    public static final int RESUMED = 9;
+
+    public static final int FAILED_RESOURCE_UNAVAILABLE = 10;
+
+}
